package de.hdm_stuttgart.mi.sd1.task2;

/**
 * <p>Representing a computer game's character positions.</p>
 *
 * <p>The game in question requires a grid:</p>
 *
 * <table class="goikTableDefaults">
 *     <caption>A 11×11 grid</caption>
 *     <colgroup>
 *         <col style="width: 50%;">
 *         <col style="width: 50%;">
 *     </colgroup>
 *     <tr>
 *         <td>
 *             <p>The precise nature of our characters (e.g. Knights, Kings,...) is not
 *important yet. But they'll »live« on our grid's intersection points.</p>
 *          <p>The diagram below shows two positions in
 *            <code style="color: red;">(x|y)</code> notation.</p>
 *          </td>
 *
 *         <td>
 *             <p>A character can move into {@linkplain Direction eight compass directions} starting from its
 *                »current« <code>(x|y)</code> position.</p>
 *         </td>
 *     </tr>
 *     <tr>
 *         <td>
 *            <img src="doc-files/grid.svg" alt="Grid">
 *         </td>
 *         <td>
 *           <img src="doc-files/move.svg" alt="moving">
 *         </td>
 *     </tr>
 * </table>
 *
 * <p>Characters already residing on the grid's border cannot leave the grid's confines. In the
 * above left diagram for example the character already sitting at <code style="color: red">(6|10)</code> cannot move
 * in northern, northeastern or nortwestern direction anymore. Any such attempt will be flagged as unsuccessful.</p>
 *
 * <p>The following example illustrates the expected behaviour:</p>
 *
 * <table class="goikTableDefaults">
 *  <caption>Creating and moving a {@link Position} instance.</caption>
 *  <tr>
 *    <th>Code</th>
 *    <th>Result</th>
 *  </tr>
 *  <tr>
 *    <td>
 *      <pre><code class="java"> final Position jim =
 *     new Position(3,2);               // Starting at (3|2)
 *
 * System.out.println("Start: " + jim); // Output »Start: (3|2)«
 *
 * jim.move(Direction.S);               // Moving in {@link Direction#S} to (3|1)
 * jim.move(Direction.SW);              // Moving in {@link Direction#SW} to (2|0)
 *
 * System.out.println(jim);             // Output: »(2|0)«
 *
 * System.out.println(                  // Already on southmost position:
 *     "Result moving SE: " +           // Attempt leaving grid in
 * jim.move(Direction.SE));             // {@link Direction#SE} fails.
 *
 * System.out.println(jim);             // Unchanged position (2|0)</code></pre>
 *    </td>
 *    <td>
 *      <pre><code class="nohighlight"> Start: (3|2)
 * (2|0)
 * Result moving SE: false
 * (2|0)</code></pre>
 *    </td>
 *
 *   </tr>
 * </table>
 *
 * <section class="implementationHints">
 *   <h2>Hint:</h2>
 *   <ul>
 *       <li>Consider implementing <code>toString()</code>.</li>
 *       <li>After completing your implementation un-comment
 *       {@link de.hdm_stuttgart.mi.sd1.sample.CharacterMoves#main(String[])} method's body which should
 *       then compile and run flawlessly.</li>
 *   </ul>
 *
 *   <p>Consider implementing <code>toString()</code>.</p>
 * </section>
 */
public class Position {
  // Todo: Implement me!
}
