package de.hdm_stuttgart.mi.sd1.test.ignore_me;

import org.junit.Assert;

import java.util.Arrays;

public class P {

  public final Class type;
  public final Object parameter;

  static public P[] toArray(final Object ... values) {
    return Arrays.stream(values).map(o -> new P(o)).toArray(P[]::new);
  }

  static public P n(final Object o) {
    return new P(o);
  }

  static public P n(final byte o) {
    return new P(o);
  }
  static public P n(final short o) {
    return new P(o);
  }

  static public P n(final int o) {
    return new P(o);
  }

  static public P n(final long o) {
    return new P(o);
  }

  static public P n(final float o) {
    return new P(o);
  }

  static public P n(final double o) {
    return new P(o);
  }

  static public P n(final boolean o) {
    return new P(o);
  }

  public P(final byte value) {
    parameter = value;
    type = byte.class;
  }
  public P(final short value) {
    parameter = value;
    type = short.class;
  }
  public P(final int value) {
    parameter = value;
    type = int.class;
  }
  public P(final long value) {
    parameter = value;
    type = long.class;
  }
  public P(final char value) {
    parameter = value;
    type = char.class;
  }
  public P(final float value) {
    parameter = value;
    type = float.class;
  }
  public P(final double value) {
    parameter = value;
    type = double.class;
  }
  public P(final boolean value) {
    parameter = value;
    type = boolean.class;
  }

  public P(final Object value) {
    parameter = value;
    type = value.getClass();
  }

  public P(final Class type, final Object parameter) {
    this.parameter = parameter;
    this.type = type;
  }

  public Class getType() {return type;}
  public Object getParameter() {return parameter;}

  public Object get() {
    return parameter;
  }
  public byte getByte() {
    if (type.equals(byte.class)) {
      return ((Byte) parameter);
    } else {
      Assert.fail("Cannot get byte from " + type.getSimpleName());
      return 0;
    }
  }
  public short getShort() {
    if (type.equals(short.class)) {
      return (Short) parameter;
    } else {
      Assert.fail("Cannot get short from " + type.getSimpleName());
      return 0;
    }
  }
  public int getInt() {
    if (type.equals(int.class)) {
      return (Integer) parameter;
    } else {
      Assert.fail("Cannot get int from " + type.getSimpleName());
      return 0;
    }
  }
  public long getLong() {
    if (type.equals(long.class)) {
      return (Long) parameter;
    } else {
      Assert.fail("Cannot get long from " + type.getSimpleName());
      return 0;
    }
  }

  public char getChar() {
    if (type.equals(char.class)) {
      return (Character) parameter;
    } else {
      Assert.fail("Cannot get char from " + type.getSimpleName());
      return 0;
    }
  }

  public float getFloat() {
    if (type.equals(float.class)) {
      return (Float) parameter;
    } else {
      Assert.fail("Cannot get float from " + type.getSimpleName());
      return 0;
    }
  }
  public double getDouble() {
    if (type.equals(double.class)) {
      return (Double) parameter;
    } else {
      Assert.fail("Cannot get double from " + type.getSimpleName());
      return 0;
    }
  }
  public boolean getBoolean() {
    if (type.equals(boolean.class)) {
      return (Boolean) parameter;
    } else {
      Assert.fail("Cannot get boolean from " + type.getSimpleName());
      return false;
    }
  }
}