package de.hdm_stuttgart.mi.sd1.test.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.task1._2_Purchase;
import de.hdm_stuttgart.mi.sd1.task1.extra.Day;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration"})
public class Test_2_Purchase extends ExaminationTestDefaults {

  @Test @Marking(points = 4) public void test_100_weekdays() {
    Assert.assertEquals(230, _2_Purchase.totalCosts(230, Day.MONDAY));
    Assert.assertEquals(1, _2_Purchase.totalCosts(1, Day.TUESDAY));
    Assert.assertEquals(444, _2_Purchase.totalCosts(444, Day.WEDNESDAY));
    Assert.assertEquals(111, _2_Purchase.totalCosts(111, Day.THURSDAY));
    Assert.assertEquals(321, _2_Purchase.totalCosts(321, Day.FRIDAY));
  }
  @Test @Marking(points = 8) public void test_120_weekend() {

    // +100 €-cent service fee
    Assert.assertEquals(154, _2_Purchase.totalCosts(54, Day.SATURDAY));
    Assert.assertEquals(865, _2_Purchase.totalCosts(765, Day.SATURDAY));

    // +200 €-cent service fee
    Assert.assertEquals(3657, _2_Purchase.totalCosts(3457, Day.SUNDAY));
    Assert.assertEquals(212, _2_Purchase.totalCosts(12, Day.SUNDAY));
  }
}
