package de.hdm_stuttgart.mi.sd1.test.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.task1._4_ArrayOrder;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_4_ArrayOrder extends ExaminationTestDefaults {

  @Test @Marking (points = 3) public void test_100_strictlyAscendingStandard() {
    Assert.assertTrue(_4_ArrayOrder.isInAscendingOrder(new int[]{1, 4, 7}));
    Assert.assertFalse(_4_ArrayOrder.isInAscendingOrder(new int[]{-1, -2, 0}));
    Assert.assertTrue(_4_ArrayOrder.isInAscendingOrder(new int[]{-5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5}));
  }

  @Test @Marking (points = 3) public void test_120_strictlyAscendingSpecial() {
    Assert.assertTrue(_4_ArrayOrder.isInAscendingOrder(new int[]{}));
    Assert.assertTrue(_4_ArrayOrder.isInAscendingOrder(new int[]{99}));
    Assert.assertTrue(_4_ArrayOrder.isInAscendingOrder(new int[]{99, 100}));
    Assert.assertFalse(_4_ArrayOrder.isInAscendingOrder(new int[]{200, 90}));
    Assert.assertTrue(_4_ArrayOrder.isInAscendingOrder(new int[]{1, 4, 7}));
    Assert.assertFalse(_4_ArrayOrder.isInAscendingOrder(new int[]{-1, -2, 0}));
  }

  @Test @Marking(points = 3) public void test_140_Ascending() {
    Assert.assertTrue(_4_ArrayOrder.isInAscendingOrder(new int[]{-1, 0, 0, 0, 4, 4}));
    Assert.assertTrue(_4_ArrayOrder.isInAscendingOrder(new int[]{-2, -2, 0, 0, 4, 5}));
    Assert.assertTrue(_4_ArrayOrder.isInAscendingOrder(new int[]{-3, -2, 0, 0, 5, 5}));
    Assert.assertFalse(_4_ArrayOrder.isInAscendingOrder(new int[]{1, 1, 1, 0}));
    Assert.assertFalse(_4_ArrayOrder.isInAscendingOrder(new int[]{2, 1, 1, 1}));
  }
}
