package de.hdm_stuttgart.mi.sd1.test.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.task1._5_Scrabble;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration"})
public class Test_5_Scrabble extends ExaminationTestDefaults {

  @Test @Marking(points = 1) public void test_100_singleLetter() {
    Assert.assertEquals(1, _5_Scrabble.getScore("a"));
    Assert.assertEquals(3, _5_Scrabble.getScore("b"));
    Assert.assertEquals(3, _5_Scrabble.getScore("c"));
    Assert.assertEquals(2, _5_Scrabble.getScore("d"));
    Assert.assertEquals(1, _5_Scrabble.getScore("e"));
    Assert.assertEquals(4, _5_Scrabble.getScore("f"));
    Assert.assertEquals(2, _5_Scrabble.getScore("g"));
    Assert.assertEquals(4, _5_Scrabble.getScore("h"));
    Assert.assertEquals(1, _5_Scrabble.getScore("i"));
    Assert.assertEquals(8, _5_Scrabble.getScore("j"));
    Assert.assertEquals(5, _5_Scrabble.getScore("k"));
    Assert.assertEquals(1, _5_Scrabble.getScore("l"));
    Assert.assertEquals(3, _5_Scrabble.getScore("m"));
    Assert.assertEquals(1, _5_Scrabble.getScore("n"));
    Assert.assertEquals(1, _5_Scrabble.getScore("o"));
    Assert.assertEquals(3, _5_Scrabble.getScore("p"));
    Assert.assertEquals(10, _5_Scrabble.getScore("q"));
    Assert.assertEquals(1, _5_Scrabble.getScore("r"));
    Assert.assertEquals(1, _5_Scrabble.getScore("s"));
    Assert.assertEquals(1, _5_Scrabble.getScore("t"));
    Assert.assertEquals(1, _5_Scrabble.getScore("u"));
    Assert.assertEquals(4, _5_Scrabble.getScore("v"));
    Assert.assertEquals(4, _5_Scrabble.getScore("w"));
    Assert.assertEquals(8, _5_Scrabble.getScore("x"));
    Assert.assertEquals(4, _5_Scrabble.getScore("y"));
    Assert.assertEquals(10, _5_Scrabble.getScore("z"));

    Assert.assertEquals(1, _5_Scrabble.getScore("A"));
    Assert.assertEquals(3, _5_Scrabble.getScore("B"));
    Assert.assertEquals(3, _5_Scrabble.getScore("C"));
    Assert.assertEquals(2, _5_Scrabble.getScore("D"));
    Assert.assertEquals(1, _5_Scrabble.getScore("E"));
    Assert.assertEquals(4, _5_Scrabble.getScore("F"));
    Assert.assertEquals(2, _5_Scrabble.getScore("G"));
    Assert.assertEquals(4, _5_Scrabble.getScore("H"));
    Assert.assertEquals(1, _5_Scrabble.getScore("I"));
    Assert.assertEquals(8, _5_Scrabble.getScore("J"));
    Assert.assertEquals(5, _5_Scrabble.getScore("K"));
    Assert.assertEquals(1, _5_Scrabble.getScore("L"));
    Assert.assertEquals(3, _5_Scrabble.getScore("M"));
    Assert.assertEquals(1, _5_Scrabble.getScore("N"));
    Assert.assertEquals(1, _5_Scrabble.getScore("O"));
    Assert.assertEquals(3, _5_Scrabble.getScore("P"));
    Assert.assertEquals(10, _5_Scrabble.getScore("Q"));
    Assert.assertEquals(1, _5_Scrabble.getScore("R"));
    Assert.assertEquals(1, _5_Scrabble.getScore("S"));
    Assert.assertEquals(1, _5_Scrabble.getScore("T"));
    Assert.assertEquals(1, _5_Scrabble.getScore("U"));
    Assert.assertEquals(4, _5_Scrabble.getScore("V"));
    Assert.assertEquals(4, _5_Scrabble.getScore("W"));
    Assert.assertEquals(8, _5_Scrabble.getScore("X"));
    Assert.assertEquals(4, _5_Scrabble.getScore("Y"));
    Assert.assertEquals(10, _5_Scrabble.getScore("Z"));
  }

  @Test @Marking(points = 1) public void test_140_shortWord() {
    Assert.assertEquals(2, _5_Scrabble.getScore("At"));
    Assert.assertEquals(12, _5_Scrabble.getScore("Zoo"));
                                                             // 10||
                                                             // + 1|
                                                             //  + 1
    Assert.assertEquals(6, _5_Scrabble.getScore("street"));
                                                             // 1|||||
                                                             //+ 1||||
                                                             // + 1|||
                                                             //  + 1||
                                                             //   + 1|
                                                             //    + 1
    Assert.assertEquals(22, _5_Scrabble.getScore("quirky"));
                                                             // 10|||||
                                                             // + 1||||
                                                             //  + 1|||
                                                             //   + 1||
                                                             //    + 5|
                                                             //     + 4

    Assert.assertEquals(8, _5_Scrabble.getScore("pinata"));
                                                            //  3|||||
                                                            // + 1||||
                                                            //  + 1|||
                                                            //   + 1||
                                                            //    + 1|
                                                            //     + 1
  }

  @Test @Marking(points = 1) public void test_180_MixCaseAndLongWord() {
    Assert.assertEquals(14, _5_Scrabble.getScore("cabbage"));
                                                             //  3||||||
                                                             // + 1|||||
                                                             //  + 3||||
                                                             //   + 3|||
                                                             //    + 1||
                                                             //     + 2|
                                                             //      + 1

    Assert.assertEquals(41, _5_Scrabble.getScore("OxyphenButazone"));
    Assert.assertEquals(27, _5_Scrabble.getScore("CYPHERTEXT"));
  }

  @Test @Marking(points = 1) public void testAnEmptyInput() {
    Assert.assertEquals(0, _5_Scrabble.getScore(""));
    Assert.assertEquals(0, _5_Scrabble.getScore(null));
  }

  @Test @Marking(points = 1) public void testEntireAlphabetAvailable() {
    Assert.assertEquals(87, _5_Scrabble.getScore("abcdefghijklmnopqrstuvwxyz"));
    Assert.assertEquals(87, _5_Scrabble.getScore("ABCDEFGHIJKLMNOPQRSTUVWXYZ"));
    Assert.assertEquals(87, _5_Scrabble.getScore("AbCDeFGHIjKLMNOpQRSTuVWXYz"));
  }
}
